;;;; -*- lisp -*-

(in-package :it.bese.tar)

;;;; Notice that we consider EVERY tar file to be in the USTAR format.

(defclass tar-file-record ()
  ((offset       :accessor record.offset       :initform 0   :initarg :offset
                 :documentation "The offset of the start of this record from within the file")
   (extract-from :accessor record.extract-file :initform nil :initarg :extract-from
                 :documentation "The truename of the file which contains this record")
   (dirty-p      :accessor record.dirty-p      :initform t   :initarg :dirty-p
                 :documentation "If the data regarding this record has
                 been changed from it's on disk representation")
   (name         :accessor record.name         :initform nil :initarg :name)
   (mode         :accessor record.mode         :initform nil :initarg :mode)
   (uid          :accessor record.uid          :initform nil :initarg :uid)
   (gid          :accessor record.gid          :initform nil :initarg :gid)
   (size         :accessor record.size         :initform nil :initarg :size)
   (mtime        :accessor record.mtime        :initform nil :initarg :mtime)
   (chksum       :accessor record.chksum       :initform nil :initarg :chksum)
   (typeflag     :accessor record.typeflag     :initform nil :initarg :typeflag)
   (linkname     :accessor record.linkname     :initform nil :initarg :linkname)
   (magic        :accessor record.magic        :initform nil :initarg :magic
                 :documentation "not functionally important")
   (version      :accessor record.version      :initform nil :initarg :version)
   (uname        :accessor record.uname        :initform nil :initarg :uname)
   (gname        :accessor record.gname        :initform nil :initarg :gname)
   (devmajor     :accessor record.devmajor     :initform nil :initarg :devmajor)
   (devminor     :accessor record.devminor     :initform nil :initarg :devminor)
   (prefix       :accessor record.prefix       :initform nil :initarg :prefix)
   (data         :accessor record.data         :initform nil :initarg :data)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Copyright (c) 2002-2003, Edward Marco Baringer
;;;; All rights reserved. 
;;;; 
;;;; Redistribution and use in source and binary forms, with or without
;;;; modification, are permitted provided that the following conditions are
;;;; met:
;;;; 
;;;;  - Redistributions of source code must retain the above copyright
;;;;    notice, this list of conditions and the following disclaimer.
;;;; 
;;;;  - Redistributions in binary form must reproduce the above copyright
;;;;    notice, this list of conditions and the following disclaimer in the
;;;;    documentation and/or other materials provided with the distribution.
;;;;
;;;;  - Neither the name of Edward Marco Baringer, nor BESE, nor the names
;;;;    of its contributors may be used to endorse or promote products
;;;;    derived from this software without specific prior written permission.
;;;; 
;;;; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;;;; "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;;;; LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
;;;; A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
;;;; OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
;;;; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
;;;; LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
;;;; DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
;;;; THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
;;;; (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
;;;; OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
